doomemacs/bin/org-capture

43 lines
1.1 KiB
Plaintext
Raw Normal View History

2017-04-22 13:49:44 +08:00
#!/usr/bin/env bash
# Open an org-capture popup frame from the shell. This opens a temporary emacs
# daemon if emacs isn't already running.
#
# Usage: org-capture [-k KEY] [MESSAGE]
2017-04-22 13:49:44 +08:00
# Examples:
# org-capture -k n "To the mind that is still, the whole universe surrenders."
2017-04-22 13:49:44 +08:00
set -e
cleanup() {
emacsclient --eval '(let (kill-emacs-hook) (kill-emacs))'
2017-04-22 13:49:44 +08:00
}
# If emacs isn't running, we start a temporary daemon, solely for this window.
if ! emacsclient -e nil; then
emacs --daemon
trap cleanup EXIT INT TERM
daemon=1
2017-04-22 13:49:44 +08:00
fi
# org-capture key mapped to argument flags
# keys=$(emacsclient -e "(+org-capture-available-keys)" | cut -d '"' -f2)
while getopts hk opt; do
key="\"$opt\""
break
done
shift $((OPTIND-1))
[ -t 0 ] && str="$*" || str=$(cat)
if [[ $daemon ]]; then
emacsclient -a "" \
-c -F '((name . "org-capture") (width . 70) (height . 25) (transient . t))' \
-e "(+org-capture/open-frame \"$str\" ${key:-nil})"
else
# Non-daemon servers flicker a lot if frames are created from terminal, so we
# do it internally instead.
emacsclient -a "" \
-e "(+org-capture/open-frame \"$str\" ${key:-nil})"
fi